Hex Artifact Content

Artifact defad127372259df5494d45aed057d1fb1e05dc4:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 64 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a 09  n download() {..
0130: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67  if [ ! -e "${pkg
0140: 61 72 63 68 69 76 65 7d 22 20 5d 3b 20 74 68 65  archive}" ]; the
0150: 6e 0a 09 09 23 20 44 6f 77 6e 6c 6f 61 64 0a 09  n...# Download..
0160: 09 23 23 20 43 6c 65 61 6e 75 70 0a 09 09 72 6d  .## Cleanup...rm
0170: 20 2d 66 20 73 72 63 2e 6e 65 77 0a 0a 09 09 23   -f src.new....#
0180: 23 20 46 65 74 63 68 20 66 69 6c 65 0a 09 09 77  # Fetch file...w
0190: 67 65 74 20 2d 4f 20 73 72 63 2e 6e 65 77 20 22  get -O src.new "
01a0: 24 7b 75 72 6c 7d 22 20 7c 7c 20 65 78 69 74 20  ${url}" || exit 
01b0: 31 0a 0a 09 09 23 23 20 56 65 72 69 66 79 20 73  1....## Verify s
01c0: 69 67 6e 61 74 75 72 65 0a 09 09 73 72 63 5f 73  ignature...src_s
01d0: 68 61 32 35 36 3d 22 24 28 6f 70 65 6e 73 73 6c  ha256="$(openssl
01e0: 20 73 68 61 32 35 36 20 27 73 72 63 2e 6e 65 77   sha256 'src.new
01f0: 27 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 3d 20  ' | sed 's@^.*= 
0200: 40 40 27 29 22 0a 09 09 69 66 20 5b 20 22 24 7b  @@')"...if [ "${
0210: 73 72 63 5f 73 68 61 32 35 36 7d 22 20 21 3d 20  src_sha256}" != 
0220: 22 24 7b 73 68 61 32 35 36 7d 22 20 5d 3b 20 74  "${sha256}" ]; t
0230: 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 53 48 41  hen....echo "SHA
0240: 32 35 36 20 6d 69 73 6d 61 74 63 68 3a 20 20 44  256 mismatch:  D
0250: 6f 77 6e 6c 6f 61 64 65 64 3a 20 24 7b 73 72 63  ownloaded: ${src
0260: 5f 73 68 61 32 35 36 7d 20 21 3d 20 45 78 70 65  _sha256} != Expe
0270: 63 74 65 64 3a 20 24 7b 73 68 61 32 35 36 7d 22  cted: ${sha256}"
0280: 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20 31 0a   >&2.....exit 1.
0290: 09 09 66 69 0a 0a 09 09 23 23 20 4d 6f 76 65 20  ..fi....## Move 
02a0: 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61 63 65 0a  file into place.
02b0: 09 09 6d 76 20 73 72 63 2e 6e 65 77 20 22 24 7b  ..mv src.new "${
02c0: 70 6b 67 61 72 63 68 69 76 65 7d 22 0a 09 66 69  pkgarchive}"..fi
02d0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 65 78 74  .}..function ext
02e0: 72 61 63 74 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ract() {..local 
02f0: 64 65 63 6f 6d 70 72 65 73 73 0a 0a 09 23 20 44  decompress...# D
0300: 65 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76  ecompress archiv
0310: 65 0a 09 23 23 20 44 65 74 65 72 6d 69 6e 65 20  e..## Determine 
0320: 74 79 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a  type of archive.
0330: 09 63 61 73 65 20 22 24 7b 75 72 6c 7d 22 20 69  .case "${url}" i
0340: 6e 0a 09 09 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74  n...*.tar.xz|*.t
0350: 61 72 2e 78 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29  ar.xz'?'*|*.txz)
0360: 0a 09 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  ....decompress='
0370: 78 7a 27 0a 09 09 09 3b 3b 0a 09 09 2a 2e 74 61  xz'....;;...*.ta
0380: 72 2e 67 7a 7c 2a 2e 74 61 72 2e 67 7a 27 3f 27  r.gz|*.tar.gz'?'
0390: 2a 7c 2a 2e 74 67 7a 29 0a 09 09 09 64 65 63 6f  *|*.tgz)....deco
03a0: 6d 70 72 65 73 73 3d 27 67 7a 69 70 27 0a 09 09  mpress='gzip'...
03b0: 09 3b 3b 0a 09 09 2a 2e 74 61 72 2e 62 7a 32 7c  .;;...*.tar.bz2|
03c0: 2a 2e 74 61 72 2e 62 7a 32 27 3f 27 2a 7c 2a 2e  *.tar.bz2'?'*|*.
03d0: 74 62 7a 32 29 0a 09 09 09 64 65 63 6f 6d 70 72  tbz2)....decompr
03e0: 65 73 73 3d 27 62 7a 69 70 32 27 0a 09 09 09 3b  ess='bzip2'....;
03f0: 3b 0a 09 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70 27  ;...*.zip|*.zip'
0400: 3f 27 2a 29 0a 09 09 09 64 65 63 6f 6d 70 72 65  ?'*)....decompre
0410: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 09 3b 3b  ss='unzip'....;;
0420: 0a 09 09 2a 29 0a 09 09 09 65 63 68 6f 20 22 55  ...*)....echo "U
0430: 6e 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69  nknown compressi
0440: 6f 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c  on method: ${url
0450: 7d 22 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20  }" >&2.....exit 
0460: 31 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09  1....;;..esac...
0470: 23 23 20 44 6f 20 64 65 63 6f 6d 70 72 65 73 73  ## Do decompress
0480: 69 6f 6e 0a 09 63 61 73 65 20 22 24 7b 64 65 63  ion..case "${dec
0490: 6f 6d 70 72 65 73 73 7d 22 20 69 6e 0a 09 09 75  ompress}" in...u
04a0: 6e 7a 69 70 29 0a 09 09 09 75 6e 7a 69 70 20 22  nzip)....unzip "
04b0: 24 7b 70 6b 67 61 72 63 68 69 76 65 7d 22 20 7c  ${pkgarchive}" |
04c0: 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74 6f  | die 'Unable to
04d0: 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63 68   uncompress arch
04e0: 69 76 65 27 0a 09 09 09 3b 3b 0a 09 09 2a 29 0a  ive'....;;...*).
04f0: 09 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0500: 7d 22 20 2d 64 63 20 22 24 7b 70 6b 67 61 72 63  }" -dc "${pkgarc
0510: 68 69 76 65 7d 22 20 7c 20 74 61 72 20 2d 78 66  hive}" | tar -xf
0520: 20 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c   - || die 'Unabl
0530: 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20  e to uncompress 
0540: 61 72 63 68 69 76 65 27 0a 09 09 09 3b 3b 0a 09  archive'....;;..
0550: 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  esac.}..function
0560: 20 76 65 72 69 66 79 52 65 71 75 69 72 65 64 50   verifyRequiredP
0570: 61 63 6b 61 67 65 73 28 29 20 7b 0a 09 6c 6f 63  ackages() {..loc
0580: 61 6c 20 70 6b 67 20 70 6b 67 64 6f 6d 61 69 6e  al pkg pkgdomain
0590: 20 70 6b 67 76 65 72 73 69 6f 6e 0a 09 6c 6f 63   pkgversion..loc
05a0: 61 6c 20 70 6b 67 64 69 72 20 70 6b 67 63 6f 6e  al pkgdir pkgcon
05b0: 66 69 67 64 69 72 20 70 6b 67 66 6f 75 6e 64 0a  figdir pkgfound.
05c0: 0a 09 66 6f 72 20 70 6b 67 20 69 6e 20 22 24 7b  ..for pkg in "${
05d0: 72 65 71 75 69 72 65 5b 40 5d 7d 22 3b 20 64 6f  require[@]}"; do
05e0: 0a 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 27 27 0a  ...pkgdomain=''.
05f0: 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 27 27 0a  ..pkgversion=''.
0600: 09 09 70 6b 67 63 68 61 6e 67 65 73 3d 28 43 46  ..pkgchanges=(CF
0610: 4c 41 47 53 20 4c 44 46 4c 41 47 53 20 50 41 54  LAGS LDFLAGS PAT
0620: 48 20 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54  H PKG_CONFIG_PAT
0630: 48 29 0a 0a 09 09 63 61 73 65 20 22 24 7b 70 6b  H)....case "${pk
0640: 67 7d 22 20 69 6e 0a 09 09 09 2a 3a 2a 29 0a 09  g}" in....*:*)..
0650: 09 09 09 70 6b 67 63 68 61 6e 67 65 73 3d 28 24  ...pkgchanges=($
0660: 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c  (echo "${pkg}" |
0670: 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 3a 27   cut -f 2 -d ':'
0680: 29 29 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63  )).....pkg="$(ec
0690: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
06a0: 74 20 2d 66 20 31 20 2d 64 20 27 3a 27 29 22 0a  t -f 1 -d ':')".
06b0: 09 09 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09  ....;;...esac...
06c0: 09 63 61 73 65 20 22 24 7b 70 6b 67 7d 22 20 69  .case "${pkg}" i
06d0: 6e 0a 09 09 09 2a 2f 2a 40 2a 29 0a 09 09 09 09  n....*/*@*).....
06e0: 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 28 65 63 68  pkgdomain="$(ech
06f0: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
0700: 20 2d 66 20 32 20 2d 64 20 27 40 27 29 22 0a 09   -f 2 -d '@')"..
0710: 09 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24  ...pkgversion="$
0720: 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c  (echo "${pkg}" |
0730: 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 2f 27   cut -f 2 -d '/'
0740: 20 7c 20 63 75 74 20 2d 66 20 31 20 2d 64 20 27   | cut -f 1 -d '
0750: 40 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28  @')".....pkg="$(
0760: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
0770: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 2f 27 29  cut -f 1 -d '/')
0780: 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 2f 2a 29  ".....;;....*/*)
0790: 0a 09 09 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d  .....pkgversion=
07a0: 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22  "$(echo "${pkg}"
07b0: 20 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27   | cut -f 2 -d '
07c0: 2f 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28  /')".....pkg="$(
07d0: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
07e0: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 2f 27 29  cut -f 1 -d '/')
07f0: 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 40 2a 29  ".....;;....*@*)
0800: 0a 09 09 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22  .....pkgdomain="
0810: 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20  $(echo "${pkg}" 
0820: 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 40  | cut -f 2 -d '@
0830: 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28 65  ')".....pkg="$(e
0840: 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63  cho "${pkg}" | c
0850: 75 74 20 2d 66 20 31 20 2d 64 20 27 40 27 29 22  ut -f 1 -d '@')"
0860: 0a 09 09 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a  .....;;...esac..
0870: 09 09 69 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67  ..if [ -z "${pkg
0880: 64 6f 6d 61 69 6e 7d 22 20 5d 3b 20 74 68 65 6e  domain}" ]; then
0890: 0a 09 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24  ....pkgdomain="$
08a0: 7b 64 6f 6d 61 69 6e 7d 22 0a 09 09 66 69 0a 0a  {domain}"...fi..
08b0: 09 09 70 6b 67 66 6f 75 6e 64 3d 27 30 27 0a 09  ..pkgfound='0'..
08c0: 09 66 6f 72 20 70 6b 67 64 69 72 20 69 6e 20 22  .for pkgdir in "
08d0: 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67  /opt/appfs/${pkg
08e0: 64 6f 6d 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70  domain}/${pkg}/p
08f0: 6c 61 74 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65  latform"/${pkgve
0900: 72 73 69 6f 6e 3a 2d 2a 7d 3b 20 64 6f 0a 09 09  rsion:-*}; do...
0910: 09 70 6b 67 63 6f 6e 66 69 67 64 69 72 3d 22 24  .pkgconfigdir="$
0920: 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 2f 70 6b 67  {pkgdir}/lib/pkg
0930: 63 6f 6e 66 69 67 22 0a 0a 09 09 09 69 66 20 5b  config".....if [
0940: 20 2d 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20   -d "${pkgdir}" 
0950: 5d 3b 20 74 68 65 6e 0a 09 09 09 09 70 6b 67 66  ]; then.....pkgf
0960: 6f 75 6e 64 3d 27 31 27 0a 09 09 09 66 69 0a 0a  ound='1'....fi..
0970: 09 09 09 66 6f 72 20 70 6b 67 63 68 61 6e 67 65  ...for pkgchange
0980: 20 69 6e 20 22 24 7b 70 6b 67 63 68 61 6e 67 65   in "${pkgchange
0990: 73 5b 40 5d 7d 22 3b 20 64 6f 0a 09 09 09 09 63  s[@]}"; do.....c
09a0: 61 73 65 20 22 24 7b 70 6b 67 63 68 61 6e 67 65  ase "${pkgchange
09b0: 7d 22 20 69 6e 0a 09 09 09 09 09 43 46 4c 41 47  }" in......CFLAG
09c0: 53 29 0a 09 09 09 09 09 09 43 46 4c 41 47 53 3d  S).......CFLAGS=
09d0: 22 24 7b 43 46 4c 41 47 53 7d 20 2d 49 24 7b 70  "${CFLAGS} -I${p
09e0: 6b 67 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a  kgdir}/include".
09f0: 09 09 09 09 09 09 43 50 50 46 4c 41 47 53 3d 22  ......CPPFLAGS="
0a00: 24 7b 43 50 50 46 4c 41 47 53 7d 20 2d 49 24 7b  ${CPPFLAGS} -I${
0a10: 70 6b 67 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22  pkgdir}/include"
0a20: 0a 09 09 09 09 09 09 65 78 70 6f 72 74 20 43 46  .......export CF
0a30: 4c 41 47 53 20 43 50 50 46 4c 41 47 53 0a 09 09  LAGS CPPFLAGS...
0a40: 09 09 09 09 3b 3b 0a 09 09 09 09 09 4c 44 46 4c  ....;;......LDFL
0a50: 41 47 53 29 0a 09 09 09 09 09 09 4c 44 46 4c 41  AGS).......LDFLA
0a60: 47 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20 2d  GS="${LDFLAGS} -
0a70: 4c 24 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 20 2d  L${pkgdir}/lib -
0a80: 57 6c 2c 2d 72 70 61 74 68 2c 24 7b 70 6b 67 64  Wl,-rpath,${pkgd
0a90: 69 72 7d 2f 6c 69 62 22 0a 09 09 09 09 09 09 65  ir}/lib".......e
0aa0: 78 70 6f 72 74 20 4c 44 46 4c 41 47 53 0a 09 09  xport LDFLAGS...
0ab0: 09 09 09 09 3b 3b 0a 09 09 09 09 09 50 41 54 48  ....;;......PATH
0ac0: 29 0a 09 09 09 09 09 09 50 41 54 48 3d 22 24 7b  ).......PATH="${
0ad0: 50 41 54 48 7d 3a 24 7b 70 6b 67 64 69 72 7d 2f  PATH}:${pkgdir}/
0ae0: 62 69 6e 22 0a 09 09 09 09 09 09 65 78 70 6f 72  bin".......expor
0af0: 74 20 50 41 54 48 0a 09 09 09 09 09 09 3b 3b 0a  t PATH.......;;.
0b00: 09 09 09 09 09 50 4b 47 5f 43 4f 4e 46 49 47 5f  .....PKG_CONFIG_
0b10: 50 41 54 48 29 0a 09 09 09 09 09 09 69 66 20 5b  PATH).......if [
0b20: 20 2d 64 20 22 24 7b 70 6b 67 63 6f 6e 66 69 67   -d "${pkgconfig
0b30: 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  dir}" ]; then...
0b40: 09 09 09 09 09 50 4b 47 5f 43 4f 4e 46 49 47 5f  .....PKG_CONFIG_
0b50: 50 41 54 48 3d 22 24 7b 50 4b 47 5f 43 4f 4e 46  PATH="${PKG_CONF
0b60: 49 47 5f 50 41 54 48 7d 3a 24 7b 70 6b 67 63 6f  IG_PATH}:${pkgco
0b70: 6e 66 69 67 64 69 72 7d 22 0a 09 09 09 09 09 09  nfigdir}".......
0b80: 09 65 78 70 6f 72 74 20 50 4b 47 5f 43 4f 4e 46  .export PKG_CONF
0b90: 49 47 5f 50 41 54 48 0a 09 09 09 09 09 09 66 69  IG_PATH.......fi
0ba0: 0a 09 09 09 09 09 09 3b 3b 0a 09 09 09 09 65 73  .......;;.....es
0bb0: 61 63 0a 09 09 09 64 6f 6e 65 0a 09 09 64 6f 6e  ac....done...don
0bc0: 65 0a 0a 09 09 69 66 20 5b 20 22 24 7b 70 6b 67  e....if [ "${pkg
0bd0: 66 6f 75 6e 64 7d 22 20 3d 20 27 30 27 20 5d 3b  found}" = '0' ];
0be0: 20 74 68 65 6e 0a 09 09 09 64 69 65 20 22 50 61   then....die "Pa
0bf0: 63 6b 61 67 65 20 24 7b 70 6b 67 7d 2f 24 7b 70  ckage ${pkg}/${p
0c00: 6b 67 76 65 72 73 69 6f 6e 3a 2d 2a 7d 40 24 7b  kgversion:-*}@${
0c10: 70 6b 67 64 6f 6d 61 69 6e 7d 20 6e 6f 74 20 66  pkgdomain} not f
0c20: 6f 75 6e 64 2e 22 0a 09 09 66 69 0a 09 64 6f 6e  ound."...fi..don
0c30: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 76 65  e.}..function ve
0c40: 72 69 66 79 50 72 65 72 65 71 75 69 73 69 74 65  rifyPrerequisite
0c50: 73 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63  s() {..:.}..func
0c60: 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e 65 4f 73  tion determineOs
0c70: 41 72 63 68 28 29 20 7b 0a 09 6f 73 3d 22 24 28  Arch() {..os="$(
0c80: 75 6e 61 6d 65 20 2d 73 20 7c 20 64 64 20 63 6f  uname -s | dd co
0c90: 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f  nv=lcase 2>/dev/
0ca0: 6e 75 6c 6c 29 22 0a 09 61 72 63 68 3d 22 24 28  null)"..arch="$(
0cb0: 75 6e 61 6d 65 20 2d 6d 20 7c 20 64 64 20 63 6f  uname -m | dd co
0cc0: 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f  nv=lcase 2>/dev/
0cd0: 6e 75 6c 6c 29 22 0a 0a 09 63 61 73 65 20 22 24  null)"...case "$
0ce0: 7b 61 72 63 68 7d 22 20 69 6e 0a 09 09 69 3f 38  {arch}" in...i?8
0cf0: 36 29 0a 09 09 09 61 72 63 68 3d 27 69 78 38 36  6)....arch='ix86
0d00: 27 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 7d 0a  '....;;..esac.}.
0d10: 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74 65 72 6d  .function determ
0d20: 69 6e 65 50 72 65 66 69 78 28 29 20 7b 0a 09 64  inePrefix() {..d
0d30: 65 74 65 72 6d 69 6e 65 4f 73 41 72 63 68 0a 0a  etermineOsArch..
0d40: 09 70 72 65 66 69 78 73 75 66 66 69 78 3d 22 24  .prefixsuffix="$
0d50: 7b 70 6b 67 7d 2f 24 7b 6f 73 7d 2d 24 7b 61 72  {pkg}/${os}-${ar
0d60: 63 68 7d 2f 24 7b 76 65 72 73 69 6f 6e 7d 22 0a  ch}/${version}".
0d70: 09 70 72 65 66 69 78 3d 22 2f 6f 70 74 2f 61 70  .prefix="/opt/ap
0d80: 70 66 73 2f 24 7b 64 6f 6d 61 69 6e 7d 2f 24 7b  pfs/${domain}/${
0d90: 70 72 65 66 69 78 73 75 66 66 69 78 7d 22 0a 09  prefixsuffix}"..
0da0: 64 65 73 74 64 69 72 3d 22 24 28 70 77 64 29 2f  destdir="$(pwd)/
0db0: 49 4e 53 54 22 0a 0a 09 6d 6b 64 69 72 20 22 24  INST"...mkdir "$
0dc0: 7b 64 65 73 74 64 69 72 7d 22 20 7c 7c 20 64 69  {destdir}" || di
0dd0: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72  e.}..function pr
0de0: 65 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a 09  econfigure() {..
0df0: 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f  :.}..function po
0e00: 73 74 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a  stconfigure() {.
0e10: 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63  .:.}..function c
0e20: 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a 09 67 6c  onfigure() {..gl
0e30: 69 62 63 64 69 72 3d 22 2f 6f 70 74 2f 61 70 70  ibcdir="/opt/app
0e40: 66 73 2f 63 6f 72 65 2e 61 70 70 66 73 2e 72 6b  fs/core.appfs.rk
0e50: 65 65 6e 65 2e 6f 72 67 2f 67 6c 69 62 63 2f 70  eene.org/glibc/p
0e60: 6c 61 74 66 6f 72 6d 2f 6c 61 74 65 73 74 22 0a  latform/latest".
0e70: 09 64 79 6e 6c 69 6e 6b 65 72 3d 22 24 28 6c 73  .dynlinker="$(ls
0e80: 20 22 24 7b 67 6c 69 62 63 64 69 72 7d 22 2f 6c   "${glibcdir}"/l
0e90: 69 62 2f 6c 64 2d 6c 69 6e 75 78 2a 2e 73 6f 2e  ib/ld-linux*.so.
0ea0: 2a 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a  * | tail -n 1)".
0eb0: 0a 09 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 64  ..if [ ! -f "${d
0ec0: 79 6e 6c 69 6e 6b 65 72 7d 22 20 5d 3b 20 74 68  ynlinker}" ]; th
0ed0: 65 6e 0a 09 09 64 69 65 20 27 67 6c 69 62 63 20  en...die 'glibc 
0ee0: 64 69 72 65 63 74 6f 72 79 20 69 73 20 6e 6f 74  directory is not
0ef0: 20 61 76 61 69 6c 61 62 6c 65 20 28 61 70 70 66   available (appf
0f00: 73 20 72 75 6e 6e 69 6e 67 2f 77 6f 72 6b 69 6e  s running/workin
0f10: 67 3f 29 27 0a 09 66 69 0a 0a 09 43 43 3d 22 24  g?)'..fi...CC="$
0f20: 7b 43 43 3a 2d 67 63 63 7d 20 2d 6e 6f 73 74 64  {CC:-gcc} -nostd
0f30: 69 6e 63 20 2d 49 24 7b 67 6c 69 62 63 64 69 72  inc -I${glibcdir
0f40: 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 4c 44 46 4c  }/include"..LDFL
0f50: 41 47 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20  AGS="${LDFLAGS} 
0f60: 2d 57 6c 2c 2d 2d 72 70 61 74 68 2c 24 7b 67 6c  -Wl,--rpath,${gl
0f70: 69 62 63 64 69 72 7d 2f 6c 69 62 20 2d 57 6c 2c  ibcdir}/lib -Wl,
0f80: 2d 2d 64 79 6e 61 6d 69 63 2d 6c 69 6e 6b 65 72  --dynamic-linker
0f90: 2c 24 7b 64 79 6e 6c 69 6e 6b 65 72 7d 22 0a 09  ,${dynlinker}"..
0fa0: 50 4b 47 5f 43 4f 4e 46 49 47 5f 4c 49 42 44 49  PKG_CONFIG_LIBDI
0fb0: 52 3d 22 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c  R="${glibcdir}/l
0fc0: 69 62 2f 70 6b 67 63 6f 6e 66 69 67 22 0a 09 65  ib/pkgconfig"..e
0fd0: 78 70 6f 72 74 20 4c 44 46 4c 41 47 53 20 50 4b  xport LDFLAGS PK
0fe0: 47 5f 43 4f 4e 46 49 47 5f 4c 49 42 44 49 52 0a  G_CONFIG_LIBDIR.
0ff0: 0a 09 2e 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d  .../configure --
1000: 70 72 65 66 69 78 3d 22 24 7b 70 72 65 66 69 78  prefix="${prefix
1010: 7d 22 20 2d 2d 73 79 73 63 6f 6e 66 64 69 72 3d  }" --sysconfdir=
1020: 22 24 7b 70 72 65 66 69 78 7d 2f 65 74 63 22 20  "${prefix}/etc" 
1030: 2d 2d 6c 69 62 64 69 72 3d 22 24 7b 70 72 65 66  --libdir="${pref
1040: 69 78 7d 2f 6c 69 62 22 20 2d 2d 6c 6f 63 61 6c  ix}/lib" --local
1050: 73 74 61 74 65 64 69 72 3d 2f 76 61 72 20 22 24  statedir=/var "$
1060: 7b 63 6f 6e 66 69 67 75 72 65 5f 65 78 74 72 61  {configure_extra
1070: 5b 40 5d 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f  [@]}".}..functio
1080: 6e 20 70 72 65 62 75 69 6c 64 28 29 20 7b 0a 09  n prebuild() {..
1090: 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f  :.}..function po
10a0: 73 74 62 75 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d  stbuild() {..:.}
10b0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69 6c 64  ..function build
10c0: 28 29 20 7b 0a 09 67 72 65 70 20 22 44 45 53 54  () {..grep "DEST
10d0: 44 49 52 22 20 4d 61 6b 65 66 69 6c 65 20 3e 2f  DIR" Makefile >/
10e0: 64 65 76 2f 6e 75 6c 6c 20 7c 7c 20 64 69 65 20  dev/null || die 
10f0: 22 44 6f 6e 27 74 20 6b 6e 6f 77 20 68 6f 77 20  "Don't know how 
1100: 74 6f 20 62 75 69 6c 64 20 74 68 69 73 20 73 6f  to build this so
1110: 66 74 77 61 72 65 22 0a 0a 09 6d 61 6b 65 0a 7d  ftware"...make.}
1120: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65 69 6e  ..function prein
1130: 73 74 61 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a  stall() {..:.}..
1140: 66 75 6e 63 74 69 6f 6e 20 70 6f 73 74 69 6e 73  function postins
1150: 74 61 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66  tall() {..:.}..f
1160: 75 6e 63 74 69 6f 6e 20 69 6e 73 74 61 6c 6c 28  unction install(
1170: 29 20 7b 0a 09 6d 61 6b 65 20 69 6e 73 74 61 6c  ) {..make instal
1180: 6c 20 44 45 53 54 44 49 52 3d 22 24 7b 64 65 73  l DESTDIR="${des
1190: 74 64 69 72 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69  tdir}".}..functi
11a0: 6f 6e 20 63 6c 65 61 6e 75 70 28 29 20 7b 0a 09  on cleanup() {..
11b0: 63 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20  cd "${workdir}" 
11c0: 7c 7c 20 65 78 69 74 20 31 0a 09 63 64 20 2e 2e  || exit 1..cd ..
11d0: 20 7c 7c 20 65 78 69 74 20 31 0a 09 72 6d 20 2d   || exit 1..rm -
11e0: 72 66 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 0a  rf "${workdir}".
11f0: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 69 65 28  }..function die(
1200: 29 20 7b 0a 09 6c 6f 63 61 6c 20 6d 65 73 73 61  ) {..local messa
1210: 67 65 0a 0a 09 6d 65 73 73 61 67 65 3d 22 24 31  ge...message="$1
1220: 22 0a 0a 09 69 66 20 5b 20 2d 6e 20 22 24 7b 6d  "...if [ -n "${m
1230: 65 73 73 61 67 65 7d 22 20 5d 3b 20 74 68 65 6e  essage}" ]; then
1240: 0a 09 09 65 63 68 6f 20 22 65 72 72 6f 72 3a 20  ...echo "error: 
1250: 24 7b 6d 65 73 73 61 67 65 7d 22 20 3e 26 32 0a  ${message}" >&2.
1260: 09 66 69 0a 0a 09 63 6c 65 61 6e 75 70 0a 0a 09  .fi...cleanup...
1270: 65 78 69 74 20 31 0a 7d 0a 0a 73 63 72 69 70 74  exit 1.}..script
1280: 64 69 72 3d 22 24 28 63 64 20 22 24 28 64 69 72  dir="$(cd "$(dir
1290: 6e 61 6d 65 20 22 24 28 77 68 69 63 68 20 22 24  name "$(which "$
12a0: 30 22 29 22 29 22 20 26 26 20 70 77 64 29 22 0a  0")")" && pwd)".
12b0: 69 66 20 5b 20 2d 7a 20 22 24 7b 73 63 72 69 70  if [ -z "${scrip
12c0: 74 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  tdir}" ]; then..
12d0: 65 63 68 6f 20 22 55 6e 61 62 6c 65 20 74 6f 20  echo "Unable to 
12e0: 6c 6f 63 61 74 65 20 73 63 72 69 70 74 20 64 69  locate script di
12f0: 72 65 63 74 6f 72 79 22 20 3e 26 32 0a 0a 09 65  rectory" >&2...e
1300: 78 69 74 20 31 0a 66 69 0a 0a 63 64 20 22 24 7b  xit 1.fi..cd "${
1310: 73 63 72 69 70 74 64 69 72 7d 22 20 7c 7c 20 65  scriptdir}" || e
1320: 78 69 74 20 31 0a 0a 69 66 20 5b 20 2d 66 20 27  xit 1..if [ -f '
1330: 62 75 69 6c 64 2e 63 6f 6e 66 27 20 5d 3b 20 74  build.conf' ]; t
1340: 68 65 6e 0a 09 2e 20 27 62 75 69 6c 64 2e 63 6f  hen... 'build.co
1350: 6e 66 27 0a 66 69 0a 0a 69 66 20 5b 20 2d 64 20  nf'.fi..if [ -d 
1360: 22 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 20 5d 3b  "pkgs/${pkg}" ];
1370: 20 74 68 65 6e 0a 09 70 6b 67 64 69 72 3d 22 70   then..pkgdir="p
1380: 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a 09 70 6b 67  kgs/${pkg}"..pkg
1390: 66 69 6c 65 3d 22 24 7b 70 6b 67 64 69 72 7d 2f  file="${pkgdir}/
13a0: 69 6e 66 6f 22 0a 65 6c 73 65 0a 09 70 6b 67 66  info".else..pkgf
13b0: 69 6c 65 3d 22 70 6b 67 73 2f 24 7b 70 6b 67 7d  ile="pkgs/${pkg}
13c0: 22 0a 09 70 6b 67 64 69 72 3d 22 24 7b 70 6b 67  "..pkgdir="${pkg
13d0: 66 69 6c 65 7d 22 0a 66 69 0a 0a 69 66 20 5b 20  file}".fi..if [ 
13e0: 21 20 2d 65 20 22 24 7b 70 6b 67 66 69 6c 65 7d  ! -e "${pkgfile}
13f0: 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20  " ]; then..echo 
1400: 22 49 6e 76 61 6c 69 64 20 70 61 63 6b 61 67 65  "Invalid package
1410: 2e 22 20 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a  ." >&2...exit 1.
1420: 66 69 0a 0a 70 6b 67 64 61 74 65 3d 22 24 28 66  fi..pkgdate="$(f
1430: 6f 72 20 61 72 74 69 66 61 63 74 20 69 6e 20 24  or artifact in $
1440: 28 66 69 6e 64 20 22 24 7b 70 6b 67 64 69 72 7d  (find "${pkgdir}
1450: 22 20 2d 74 79 70 65 20 66 20 2d 70 72 69 6e 74  " -type f -print
1460: 30 20 7c 20 78 61 72 67 73 20 2d 6e 20 31 20 2d  0 | xargs -n 1 -
1470: 30 20 66 6f 73 73 69 6c 20 66 69 6e 66 6f 20 2d  0 fossil finfo -
1480: 2d 6c 69 6d 69 74 20 31 20 2d 2d 77 69 64 74 68  -limit 1 --width
1490: 20 30 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c   0 2>/dev/null |
14a0: 20 67 72 65 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d   grep '^[0-9][0-
14b0: 39 5d 5b 30 2d 39 5d 5b 30 2d 39 5d 2d 5b 30 2d  9][0-9][0-9]-[0-
14c0: 39 5d 5b 30 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d  9][0-9]-[0-9][0-
14d0: 39 5d 20 27 20 7c 20 73 65 64 20 27 73 40 5e 5b  9] ' | sed 's@^[
14e0: 5e 20 5d 2a 20 5c 5b 40 40 3b 73 40 5c 5d 2e 2a  ^ ]* \[@@;s@\].*
14f0: 40 40 27 20 7c 20 73 6f 72 74 20 2d 75 29 3b 20  @@' | sort -u); 
1500: 64 6f 20 66 6f 73 73 69 6c 20 69 6e 66 6f 20 22  do fossil info "
1510: 24 7b 61 72 74 69 66 61 63 74 7d 22 20 7c 20 61  ${artifact}" | a
1520: 77 6b 20 27 2f 5e 75 75 69 64 3a 2f 7b 20 70 72  wk '/^uuid:/{ pr
1530: 69 6e 74 20 24 33 20 24 34 20 7d 27 20 7c 20 73  int $3 $4 }' | s
1540: 65 64 20 27 73 40 5b 2d 3a 5d 40 40 67 3b 73 40  ed 's@[-:]@@g;s@
1550: 2e 2e 24 40 5c 2e 26 40 27 3b 20 64 6f 6e 65 20  ..$@\.&@'; done 
1560: 7c 20 73 6f 72 74 20 2d 6e 20 7c 20 74 61 69 6c  | sort -n | tail
1570: 20 2d 6e 20 31 29 22 0a 69 66 20 5b 20 2d 7a 20   -n 1)".if [ -z 
1580: 22 24 7b 70 6b 67 64 61 74 65 7d 22 20 5d 3b 20  "${pkgdate}" ]; 
1590: 74 68 65 6e 0a 09 70 6b 67 64 61 74 65 3d 22 24  then..pkgdate="$
15a0: 28 66 69 6e 64 20 22 24 7b 70 6b 67 64 69 72 7d  (find "${pkgdir}
15b0: 22 20 2d 74 79 70 65 20 66 20 2d 70 72 69 6e 74  " -type f -print
15c0: 66 20 27 25 54 59 25 54 6d 25 54 64 25 54 48 25  f '%TY%Tm%Td%TH%
15d0: 54 4d 2e 25 54 53 5c 6e 27 20 32 3e 2f 64 65 76  TM.%TS\n' 2>/dev
15e0: 2f 6e 75 6c 6c 20 7c 20 63 75 74 20 2d 66 20 31  /null | cut -f 1
15f0: 2d 32 20 2d 64 20 27 2e 27 20 7c 20 73 6f 72 74  -2 -d '.' | sort
1600: 20 2d 6e 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29   -n | tail -n 1)
1610: 22 0a 66 69 0a 0a 2e 20 22 24 7b 70 6b 67 66 69  ".fi... "${pkgfi
1620: 6c 65 7d 22 0a 0a 61 72 63 68 69 76 65 64 69 72  le}"..archivedir
1630: 3d 22 24 28 70 77 64 29 2f 41 52 43 48 49 56 45  ="$(pwd)/ARCHIVE
1640: 22 0a 77 6f 72 6b 64 69 72 3d 22 77 6f 72 6b 64  ".workdir="workd
1650: 69 72 2d 24 24 24 7b 52 41 4e 44 4f 4d 7d 24 7b  ir-$$${RANDOM}${
1660: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
1670: 22 0a 70 6b 67 61 72 63 68 69 76 65 3d 22 24 7b  ".pkgarchive="${
1680: 61 72 63 68 69 76 65 64 69 72 7d 2f 24 7b 70 6b  archivedir}/${pk
1690: 67 7d 2d 24 7b 76 65 72 73 69 6f 6e 7d 22 0a 6d  g}-${version}".m
16a0: 6b 64 69 72 20 22 24 7b 61 72 63 68 69 76 65 64  kdir "${archived
16b0: 69 72 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  ir}" >/dev/null 
16c0: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 6d 6b 64 69  2>/dev/null.mkdi
16d0: 72 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c  r "${workdir}" |
16e0: 7c 20 65 78 69 74 20 31 0a 63 64 20 22 24 7b 77  | exit 1.cd "${w
16f0: 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74  orkdir}" || exit
1700: 20 31 0a 77 6f 72 6b 64 69 72 3d 22 24 28 70 77   1.workdir="$(pw
1710: 64 29 22 0a 0a 23 20 44 6f 77 6e 6c 6f 61 64 0a  d)"..# Download.
1720: 64 6f 77 6e 6c 6f 61 64 0a 0a 23 20 45 78 74 72  download..# Extr
1730: 61 63 74 0a 65 78 74 72 61 63 74 0a 0a 23 20 49  act.extract..# I
1740: 66 20 77 65 20 6a 75 73 74 20 68 61 76 65 20 6f  f we just have o
1750: 6e 65 20 64 69 72 65 63 74 6f 72 79 2c 20 75 73  ne directory, us
1760: 65 20 74 68 61 74 20 64 69 72 65 63 74 6f 72 79  e that directory
1770: 0a 64 69 72 3d 22 24 28 65 63 68 6f 20 2a 29 22  .dir="$(echo *)"
1780: 0a 69 66 20 5b 20 2d 65 20 22 24 7b 64 69 72 7d  .if [ -e "${dir}
1790: 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 76 20 22 24  " ]; then..mv "$
17a0: 7b 64 69 72 7d 22 2f 2a 20 2e 0a 66 69 0a 0a 23  {dir}"/* ..fi..#
17b0: 20 56 65 72 69 66 79 20 70 72 65 2d 72 65 71 75   Verify pre-requ
17c0: 69 73 69 74 65 73 20 61 72 65 20 6d 65 74 0a 76  isites are met.v
17d0: 65 72 69 66 79 52 65 71 75 69 72 65 64 50 61 63  erifyRequiredPac
17e0: 6b 61 67 65 73 20 7c 7c 20 64 69 65 20 27 52 65  kages || die 'Re
17f0: 71 75 69 72 65 64 20 70 61 63 6b 61 67 65 73 20  quired packages 
1800: 6d 69 73 73 69 6e 67 27 0a 76 65 72 69 66 79 50  missing'.verifyP
1810: 72 65 72 65 71 75 69 73 69 74 65 73 20 7c 7c 20  rerequisites || 
1820: 64 69 65 20 27 50 72 65 72 65 71 75 69 73 69 74  die 'Prerequisit
1830: 69 65 73 20 66 61 69 6c 65 64 27 0a 0a 23 20 53  ies failed'..# S
1840: 74 61 72 74 20 6c 6f 67 67 69 6e 67 0a 73 65 74  tart logging.set
1850: 20 2d 78 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65   -x..# Determine
1860: 20 70 72 6f 70 65 72 74 69 65 73 0a 64 65 74 65   properties.dete
1870: 72 6d 69 6e 65 50 72 65 66 69 78 0a 0a 23 20 53  rminePrefix..# S
1880: 74 61 72 74 20 74 68 65 20 62 75 69 6c 64 0a 70  tart the build.p
1890: 72 65 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64  reconfigure || d
18a0: 69 65 20 27 70 72 65 63 6f 6e 66 69 67 75 72 65  ie 'preconfigure
18b0: 20 66 61 69 6c 65 64 27 0a 63 6f 6e 66 69 67 75   failed'.configu
18c0: 72 65 20 7c 7c 20 64 69 65 20 27 63 6f 6e 66 69  re || die 'confi
18d0: 67 75 72 65 20 66 61 69 6c 65 64 27 0a 70 6f 73  gure failed'.pos
18e0: 74 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64 69  tconfigure || di
18f0: 65 20 27 70 6f 73 74 63 6f 6e 66 69 67 75 72 65  e 'postconfigure
1900: 20 66 61 69 6c 65 64 27 0a 0a 70 72 65 62 75 69   failed'..prebui
1910: 6c 64 20 7c 7c 20 64 69 65 20 27 70 72 65 62 75  ld || die 'prebu
1920: 69 6c 64 20 66 61 69 6c 65 64 27 0a 62 75 69 6c  ild failed'.buil
1930: 64 20 7c 7c 20 64 69 65 20 27 62 75 69 6c 64 20  d || die 'build 
1940: 66 61 69 6c 65 64 27 0a 70 6f 73 74 62 75 69 6c  failed'.postbuil
1950: 64 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 62 75  d || die 'postbu
1960: 69 6c 64 20 66 61 69 6c 65 64 27 0a 0a 70 72 65  ild failed'..pre
1970: 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69 65 20 27  install || die '
1980: 70 72 65 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65  preinstall faile
1990: 64 27 0a 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69  d'.install || di
19a0: 65 20 27 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65  e 'install faile
19b0: 64 27 0a 70 6f 73 74 69 6e 73 74 61 6c 6c 20 7c  d'.postinstall |
19c0: 7c 20 64 69 65 20 27 70 6f 73 74 69 6e 73 74 61  | die 'postinsta
19d0: 6c 6c 20 66 61 69 6c 65 64 27 0a 0a 28 0a 09 63  ll failed'..(..c
19e0: 61 73 65 20 22 24 7b 74 61 72 67 65 74 6d 6f 64  ase "${targetmod
19f0: 65 7d 22 20 69 6e 0a 09 09 69 6e 73 74 61 6c 6c  e}" in...install
1a00: 29 0a 09 09 09 61 70 70 64 69 72 3d 22 24 28 61  )....appdir="$(a
1a10: 70 70 66 73 69 6e 73 74 61 6c 6c 64 69 72 29 2f  ppfsinstalldir)/
1a20: 24 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d 22  ${prefixsuffix}"
1a30: 0a 09 09 09 6d 6b 64 69 72 20 2d 70 20 22 24 7b  ....mkdir -p "${
1a40: 61 70 70 64 69 72 7d 22 0a 0a 09 09 09 63 64 20  appdir}".....cd 
1a50: 22 24 7b 64 65 73 74 64 69 72 7d 2f 24 7b 70 72  "${destdir}/${pr
1a60: 65 66 69 78 7d 22 20 7c 7c 20 65 78 69 74 20 31  efix}" || exit 1
1a70: 0a 0a 09 09 09 63 70 20 2d 72 70 20 2a 20 22 24  .....cp -rp * "$
1a80: 7b 61 70 70 64 69 72 7d 22 0a 09 09 09 66 69 6e  {appdir}"....fin
1a90: 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20 2d 70  d "${appdir}" -p
1aa0: 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30  rint0 | xargs -0
1ab0: 20 74 6f 75 63 68 20 2d 74 20 22 24 7b 70 6b 67   touch -t "${pkg
1ac0: 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64 20 22  date}"....find "
1ad0: 24 7b 61 70 70 64 69 72 7d 22 20 2d 70 72 69 6e  ${appdir}" -prin
1ae0: 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f  t0 | xargs -0 to
1af0: 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b 70 6b 67  uch -m -t "${pkg
1b00: 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64 20 22  date}"....find "
1b10: 24 7b 61 70 70 64 69 72 7d 22 20 2d 70 72 69 6e  ${appdir}" -prin
1b20: 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f  t0 | xargs -0 to
1b30: 75 63 68 20 2d 61 20 2d 74 20 22 24 7b 70 6b 67  uch -a -t "${pkg
1b40: 64 61 74 65 7d 22 0a 09 09 09 3b 3b 0a 09 09 61  date}"....;;...a
1b50: 72 63 68 69 76 65 29 0a 09 09 09 61 72 63 68 69  rchive)....archi
1b60: 76 65 66 69 6c 65 3d 22 24 7b 73 63 72 69 70 74  vefile="${script
1b70: 64 69 72 7d 2f 24 7b 70 6b 67 7d 2d 24 7b 76 65  dir}/${pkg}-${ve
1b80: 72 73 69 6f 6e 7d 2d 24 28 65 63 68 6f 20 22 24  rsion}-$(echo "$
1b90: 7b 70 6b 67 64 61 74 65 7d 22 20 7c 20 73 65 64  {pkgdate}" | sed
1ba0: 20 27 73 40 5c 2e 40 40 67 27 29 2d 24 7b 6f 73   's@\.@@g')-${os
1bb0: 7d 2d 24 7b 61 72 63 68 7d 2d 24 7b 64 6f 6d 61  }-${arch}-${doma
1bc0: 69 6e 7d 2e 63 70 69 6f 22 0a 09 09 09 63 64 20  in}.cpio"....cd 
1bd0: 22 24 7b 64 65 73 74 64 69 72 7d 2f 24 7b 70 72  "${destdir}/${pr
1be0: 65 66 69 78 7d 2f 2e 2e 2f 2e 2e 2f 2e 2e 22 20  efix}/../../.." 
1bf0: 7c 7c 20 65 78 69 74 20 31 0a 09 09 09 66 69 6e  || exit 1....fin
1c00: 64 20 22 24 7b 70 72 65 66 69 78 73 75 66 66 69  d "${prefixsuffi
1c10: 78 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61  x}" -print0 | xa
1c20: 72 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 74 20  rgs -0 touch -t 
1c30: 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09  "${pkgdate}"....
1c40: 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78 73 75  find "${prefixsu
1c50: 66 66 69 78 7d 22 20 2d 70 72 69 6e 74 30 20 7c  ffix}" -print0 |
1c60: 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63 68 20   xargs -0 touch 
1c70: 2d 6d 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65  -m -t "${pkgdate
1c80: 7d 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72  }"....find "${pr
1c90: 65 66 69 78 73 75 66 66 69 78 7d 22 20 2d 70 72  efixsuffix}" -pr
1ca0: 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20  int0 | xargs -0 
1cb0: 74 6f 75 63 68 20 2d 61 20 2d 74 20 22 24 7b 70  touch -a -t "${p
1cc0: 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64  kgdate}"....find
1cd0: 20 22 24 7b 70 72 65 66 69 78 73 75 66 66 69 78   "${prefixsuffix
1ce0: 7d 22 20 7c 20 73 6f 72 74 20 7c 20 63 70 69 6f  }" | sort | cpio
1cf0: 20 2d 2d 6f 77 6e 65 72 20 30 3a 30 20 2d 48 20   --owner 0:0 -H 
1d00: 6e 65 77 63 20 2d 6f 20 3e 20 22 24 7b 61 72 63  newc -o > "${arc
1d10: 68 69 76 65 66 69 6c 65 7d 22 0a 09 09 09 3b 3b  hivefile}"....;;
1d20: 0a 09 65 73 61 63 0a 29 20 7c 7c 20 64 69 65 20  ..esac.) || die 
1d30: 27 66 69 6e 61 6c 20 69 6e 73 74 61 6c 6c 61 74  'final installat
1d40: 69 6f 6e 20 66 61 69 6c 65 64 27 0a 0a 63 6c 65  ion failed'..cle
1d50: 61 6e 75 70 0a 0a 65 78 69 74 20 30 0a           anup..exit 0.